<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
<meta charset="UTF-8">

<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
<script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>

<script>
$(function(){

	$("#form1").on("submit",function(e){
		var $form = $(e.target);
		var $array = $form.serializeArray();
		var $data = {
				multiCheckbox: []
		};

		// { name: name, value: value } => { name: value }
		for (var item of $array) {
			if (typeof $data[item.name] == "undefined") {
	            $data[item.name] = item.value;
			} else if (typeof $data[item.name] == "string") {
				$temp = $data[item.name];
				$data[item.name] = [
					$temp ,
					item.value
				]
            } else {
                $data[item.name].push(item.value);
            } 
			
		}

		var $json = JSON.stringify($data);

	    var $ajaxOptions = {
            url: $form.attr("action"),
            type: $form.attr("method"),
            contentType: "application/json",
            dataType: "json",
            data: JSON.stringify($data)
        };

        console.log([$data,$json,$ajaxOptions]);

	    $.ajax($ajaxOptions).done(function(data) {
		    console.log(data);
	    });

	    
	    return false;
    
    });

});
</script>

</head>
<body>
	<div class="container">
		<form method="post" th:object="${form}" th:action="@{/}" id="form1">
			<div class="form-group form-row">
				<label class="col-3 form-label" for="id">Id(hidden)</label>
				<div class="col">
					<input id="id" name="id" type="hidden" value="1"> 1
				</div>
			</div>
			<div class="form-group form-row">
				<label class="col-3 form-label" for="text">Text</label>
				<div class="col">
					<input th:field="*{text}" class="form-control">
				</div>
			</div>
			<div class="form-group form-row">
				<label class="col-3 form-label">Radio</label>
				<div class="col">
					<div class="form-check">
						<input class="form-check-input" name="radio" type="radio" value="0" id="radio1" checked="checked">
						<!--  -->
						<label class="form-check-label" for="radio1">いいえ</label>
					</div>
					<div class="form-check">
						<input class="form-check-input" name="radio" type="radio" value="1" id="radio2">
						<!--  -->
						<label class="form-check-label" for="radio2">はい</label>
					</div>
				</div>
			</div>
			<div class="form-group form-row">
				<label class="col-3 form-label">Checkbox</label>
				<div class="col">
					<div class="form-check">
						<input class="form-check-input" name="checkbox" type="checkbox" value="1" id="checkbox1">
						<!--  -->
						<label class="form-check-label" for="checkbox1">同意する</label>
					</div>
				</div>
			</div>
			<div class="form-group form-row">
				<label class="col-3 form-label">Multi Checkbox</label>
				<div class="col">
					<div class="form-check">
						<input class="form-check-input" name="multiCheckbox" type="checkbox" value="1" id="multiCheckbox1">
						<!--  -->
						<label class="form-check-label" for="multiCheckbox1">選択肢1</label>
					</div>
					<div class="form-check">
						<input class="form-check-input" name="multiCheckbox" type="checkbox" value="2" id="multiCheckbox2">
						<!--  -->
						<label class="form-check-label" for="multiCheckbox2">選択肢2</label>
					</div>
					<div class="form-check">
						<input class="form-check-input" name="multiCheckbox" type="checkbox" value="3" id="multiCheckbox3">
						<!--  -->
						<label class="form-check-label" for="multiCheckbox3">選択肢3</label>
					</div>
				</div>
			</div>
			<button type="submit">送信</button>
		</form>
	</div>
</body>
</html>
